=== modified file 'drizzled/parser.cc'
--- drizzled/parser.cc	2011-10-22 13:10:53 +0000
+++ drizzled/parser.cc	2011-10-24 17:33:01 +0000
@@ -326,21 +326,17 @@
   opt->set_state(boost::lexical_cast<std::string>(value));
 }
 
-bool checkFieldIdent(LEX *lex, const lex_string_t &schema_name, const lex_string_t &table_name)
+bool checkFieldIdent(LEX *lex, str_ref schema_name, str_ref table_name)
 {
   TableList *table= reinterpret_cast<TableList*>(lex->current_select->table_list.first);
 
-  if (schema_name.size())
+  if (schema_name.size() && my_strcasecmp(table_alias_charset, schema_name.data(), table->getSchemaName()))
   {
-    if (my_strcasecmp(table_alias_charset, schema_name.data(), table->getSchemaName()))
-    {
-      my_error(ER_WRONG_DB_NAME, MYF(0), schema_name.data());
-      return false;
-    }
+    my_error(ER_WRONG_DB_NAME, MYF(0), schema_name.data());
+    return false;
   }
 
-  if (my_strcasecmp(table_alias_charset, table_name.data(),
-                    table->getTableName()))
+  if (my_strcasecmp(table_alias_charset, table_name.data(), table->getTableName()))
   {
     my_error(ER_WRONG_TABLE_NAME, MYF(0), table_name.data());
     return false;
@@ -349,7 +345,7 @@
   return true;
 }
 
-Item *buildIdent(LEX *lex, const lex_string_t &schema_name, const lex_string_t &table_name, const lex_string_t &field_name)
+Item *buildIdent(LEX *lex, str_ref schema_name, str_ref table_name, str_ref field_name)
 {
   Select_Lex *sel= lex->current_select;
 
@@ -363,7 +359,7 @@
     : (Item*) new Item_ref(lex->current_context(), schema_name.data(), table_name.data(), field_name.data());
 }
 
-Item *buildTableWild(LEX *lex, const lex_string_t &schema_name, const lex_string_t &table_name)
+Item *buildTableWild(LEX *lex, str_ref schema_name, str_ref table_name)
 {
   Select_Lex *sel= lex->current_select;
   Item *item= new Item_field(lex->current_context(), schema_name.data(), table_name.data(), "*");

=== modified file 'drizzled/parser.h'
--- drizzled/parser.h	2011-10-19 17:58:50 +0000
+++ drizzled/parser.h	2011-10-24 17:33:01 +0000
@@ -126,13 +126,12 @@
 void buildSchemaOption(LEX*, const char *key, str_ref value);
 void buildSchemaOption(LEX*, const char *key, uint64_t value);
 void buildSchemaDefiner(LEX*, const identifier::User&);
-bool checkFieldIdent(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name);
+bool checkFieldIdent(LEX*, str_ref schema_name, str_ref table_name);
 
-Item *buildIdent(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name, const lex_string_t &field_name);
-Item *buildTableWild(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name);
+Item *buildIdent(LEX*, str_ref schema_name, str_ref table_name, str_ref field_name);
+Item *buildTableWild(LEX*, str_ref schema_name, str_ref table_name);
 
 void buildCreateFieldIdent(LEX*);
-
 void storeAlterColumnPosition(LEX*, const char *position);
 
 bool buildCollation(LEX*, const charset_info_st *arg);

=== modified file 'drizzled/util/data_ref.h'
--- drizzled/util/data_ref.h	2011-10-22 13:10:53 +0000
+++ drizzled/util/data_ref.h	2011-10-24 17:33:01 +0000
@@ -34,10 +34,7 @@
   template <class U>
   data_ref_basic(const U& c)
   {
-    if (c.begin() == c.end())
-      clear();
-    else
-      assign(&*c.begin(), &*c.end());
+    assign(&*c.begin(), &*c.end());
   }
 
   data_ref_basic(const void* b, const void* e)

